package com.gd.armageddon
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.utils.getTimer;

	public class Clock extends EventDispatcher
	{
		private var lastTime:int;
		private var _running:Boolean;
		private var _remaining:int;
		private var _forceRunTo:int;
		
		public function Clock()
		{
			var t:Timer = new Timer(1 / 30);
			t.start();
			t.addEventListener(TimerEvent.TIMER, onTimer);
			
			this.reset();
		}
		
		public function reset():void
		{
			lastTime = getTimer();
			_running = false;
			_remaining = 10 * 1000;
			_forceRunTo = _remaining;
		}
		
		private function onTimer(event:TimerEvent):void
		{
			var current:int = _remaining;
			
			var time:int = getTimer();
			var diff = time - lastTime;
			
			if(this.running)
			{
				_remaining = Math.max(0, _remaining - diff);
				_forceRunTo = Math.min(_forceRunTo, _remaining);
			}
			else
			{
				_remaining = Math.max(_forceRunTo, _remaining - diff);
			}
			
			if(_remaining != current)
			{
				this.dispatchEvent(new Event(Event.CHANGE));
			}
			
			lastTime = time;
		}
		
		public function get totalTime():Number
		{
			return 10;
		}
		
		public function get timeRemaining():Number
		{
			return _remaining / 1000.0;
		}

		public function get running():Boolean
		{
			return _running;
		}

		public function set running(value:Boolean):void
		{
			_running = value;
		}
		
		public function forceRunFromCurrentTimeTo(milliseconds:int):void
		{
			_forceRunTo = Math.min(_forceRunTo, Math.max(0, _forceRunTo - milliseconds));
		}
		
	}
}