package com.gd.armageddon
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.Event;
	
	public class Locale extends MovieClip
	{
		private var drillDown:Function;
		private var clickers:Array;
		private var clickResults:Array;
		private var numClicks:int = 0;
		
		public function Locale()
		{
			super();
			this.stop();
			
			// listen for initial load to insure settings are active to set into global vars
			loaderInfo.addEventListener(Event.COMPLETE, init);
		}
		
		private function init(e:Event):void
		{
			// remove the listener
			loaderInfo.removeEventListener(Event.COMPLETE, init);
			
			initialize();
		}
		
		protected function initialize():void
		{
			this.mouseEnabled = false;
			
			this.reset();
		}
		
		private function onClick():void
		{
			var time:Number = NaN;
			
			numClicks++;
			for each(var clickResult:ClickResult in clickResults)
			{
				if(numClicks == clickResult.minClicks)
				{
					if(isNaN(time))
					{
						time = 0;
					}
					
					time += clickResult.timeCost;
				}
			}
			
			if(!isNaN(time))
			{
				Armageddon.armageddon.payTimeCost(1 + time);
			}
			
			this.updateClickResults();
		}
		
		private function updateClickResults():void
		{
			for each(var clickResult:ClickResult in clickResults)
			{
				if(numClicks >= clickResult.minClicks)
				{
					clickResult.visible = true;
				}
				else
				{
					clickResult.visible = false;
				}
			}
		}
		
		public function reset():void
		{
			this.gotoAndStop(0);
			numClicks = 0;
			
			clickers = [];
			clickResults = [];
			
			for(var i:int = this.numChildren - 1; i >= 0; i--)
			{
				var child:DisplayObject = this.getChildAt(i);
				if(child is Clicker)
				{
					var clicker:Clicker = Clicker(child);
					clicker.onClick = function():void {
						onClick();
					};
					clickers.push(child);
				}
				if(child is ClickResult)
				{
					clickResults.push(child);
				}
			}
			
			this.updateClickResults();
		}
		
		public function onDrillDown(f:Function):void
		{
			drillDown = f;
		}
		
		public function update():void
		{
			var frame:int = Math.round(this.totalFrames * (1 - Armageddon.armageddon.clock.timeRemaining / Armageddon.armageddon.clock.totalTime));
			this.gotoAndStop(frame);
		}
		
	}
}