package com.gd.armageddon
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	
	public class MovieClipButton extends MovieClip
	{
		public static const STATE_NORMAL:uint = 0;
		public static const STATE_OVER:uint = 1;
		public static const STATE_DOWN:uint = 2;
		
		private var isDown:Boolean = false;
		private var isOver:Boolean = false;
		private var state:uint = 0;
		
		public function MovieClipButton()
		{
			super();
			stop();
			this.addEventListener(MouseEvent.MOUSE_OVER, over, false, 0, true);
			this.addEventListener(MouseEvent.MOUSE_OUT, out, false, 0, true);
			this.addEventListener(MouseEvent.MOUSE_DOWN, down, false, 0, true);
			this.addEventListener(MouseEvent.MOUSE_UP, up, false, 0, true);
			
			this.addEventListener(MouseEvent.CLICK, onClick, false, 0, true);
		}
		
		protected function down(event:MouseEvent):void
		{
			isDown = event.buttonDown;
			updateState();
		}
		
		protected function up(event:MouseEvent):void
		{
			isDown = event.buttonDown;
			updateState();
		}
		
		protected function out(event:MouseEvent):void
		{
			isDown = event.buttonDown;
			isOver = false;
			updateState();
		}
		
		protected function over(event:MouseEvent):void
		{
			isDown = event.buttonDown;
			isOver = true;
			updateState();
		}
		
		private function updateState():void
		{
			if(isOver && isDown)
			{
				this.changeStateTo(STATE_DOWN);
			}
			else if(isOver)
			{
				this.changeStateTo(STATE_OVER);
			}
			else if(state)
			{
				this.changeStateTo(STATE_NORMAL);
			}
		}
		
		private function tryChangeStateTo(state:uint):void
		{
			if(this.state != state)
			{
				this.changeStateTo(state);
			}
		}
		
		protected function changeStateTo(newState:uint):void
		{
			state = newState;
			if(newState <= this.totalFrames)
			{
				this.gotoAndStop(newState + 1);
			}
			else
			{
				this.gotoAndStop(0);
			}
		}
		
		private function onClick(event:MouseEvent):void
		{
			event.stopImmediatePropagation();
			this.activate();
		}
		
		protected function activate():void
		{
			//
		}
	}
}